/*     DS18B20.

 ,  2011-2012
Gennady Chernov, Dnepropetrovsk 2011-2012
 v1.04.
Microchip MPLAB XC8 C Compiler V1.12
Email: gena.chernov@gmail.com
*/

//--------------------------------------------------------------------------------------- 

void Level_High (void);		//
void Level_Low (void);		//
void Waiting_WR (void);		//
char CRC_Bits (int data);	//
char Reset_Dallas (void);	//
char Dreceive (void);		//
void Dsend (char COM_REG);	//
char Celsio (void);			//
char SeachROM (void);		//
char SaveROM (void);		//   
void EraseROM (void);		//
char Test_DT (void);		//

//--------------------------------------------------------------------------------------- 
// 
#define	COLDAT	1						//     

#define	TRISDAL	TRISA2					//    
#define	DALLAS	PORTAbits.RA2			//    1

#define	EEP_SIZE 0xFF					//  EEPROM 

#define	NACHAD	(EEP_SIZE-(8*COLDAT))+1	//        EEPROM
//#define	NACHAD	(0xFF-(8*COLDAT))+1		

#define _XTAL_FREQ 32000000 			//!!!           
//--------------------------------------------------------------------------------------- 

//
volatile bit CONV; 			//    
volatile char convert;		//       

char test;					// 
//--------------------------------------------------------------------------------------- 
//
char crc, 					// crc
coldachu,					//   (  EEPROM)
naydendatch, 				//    .
posled_nesoot,				//      
error_con;					//     
char bufdt[8], 				//      DS18B20
erroDT[COLDAT]; 			//     (  )	

int TEMPDAT[COLDAT]; 		//   ;

bit CONFLAG; 				//    
bit TESTDT;					//     (   ) 1-  
bit ET00,ET01,ET02,ET03,ET04,ET05,ET06,ET07,
ET08,ET09,ET10,ET11,ET12,ET13,ET14,ET15; //   

//------------------------------------------------------------------------------------	
/*
   !!!

1. ,       ,   
    

#define		TRISDAL	TRISA1	//    
#define		DALLAS	PORTAbits.RA1	//    1

2.    ,       
#define _XTAL_FREQ 40000000 //   40 Mh
3.         
  .   750 . 
 convert=57; 57      .   
     0,1  (    , 
   750-800     char),     
 8-9.

		if(CONV==1)
		{
			if(convert--==0)
			{
				convert=57; 		//   
				CONV=0;		//57 -  
			}
		}
				
4.  ,  ,   
  ,         
 Test_DT();

5.   Test_DT()    (,  ). 
         TESTDT=0;

6.    16.   
#define		COLDAT	4	//      4

7.      ,    EEPROM.
-     .     . 
  ,    256 .

8.       ,  
Celsio();     TEMPDAT[].    
  

ET  -  0-15.

9.  ,    .

  .

  EEPROM  ,   ,      ,
 Test_DT(),   ,    
  .       ,   
     .

     , .. ,   Test_DT()
     . ..  , 
. .     (  ) - 
 ...  ..        ,
  .



     ,       .
 (   )      
 ,     Test_DT(),   
       "" .
 


//========================================================================================

*/
