/* Magetex - 2012
* Gena Chernov catcatcat@e-mail.ua
*  ch-4000
*   +   
* 10/04/13
* v08 - 4    ,    1     
* v09 -   1 -   4   4   
* v15 -  45 
* v16 - 
* v18 -   ,    
*/
#define _XTAL_FREQ	32000000	//   

#include <htc.h>			//    
#include "indic_4led.h"		//        PIC-controlles

//================================================================================
//   PIC16F1829
//---------------------------------------------------------------------------
//   ( )
__CONFIG(
 FOSC_INTOSC & 		//  ,        
 WDTE_NSLEEP &		//      ,    
 PWRTE_OFF	&		//    -
 MCLRE_OFF	&		//  MCLR/VPP  RA3
 CP_ON		&		//     - 
 CPD_ON		&		//     (EPPROM) - 
 BOREN_ON	&		//     
 CLKOUTEN_OFF	&	//  CLKOUT       - 
 IESO_OFF	&		//   Internal/External  - 
 FCMEN_OFF);		//     - 

__CONFIG(
 WRT_ALL & 			//   -   
 PLLEN_ON 	&		//   4x PLL - 
 STVREN_OFF & 		//      
 BORV_LO 	&		//        2.7V
 LVP_OFF);			//   
//================================================================================




//---------------------------------------------------------------------------
__EEPROM_DATA(
0x33, 0x33, 	//* 
0x44, 0x44,		//4433   1
10, 10, 		// 
10, 10); 		// 
__EEPROM_DATA(
0, 0,			//   1 0-, 1 - , 2 - 
0, 0,			//   2
0, 0,			//   3
0, 0);			//   4
__EEPROM_DATA(
30, 30,			//   .
45, 45,			//    45 .
45, 45,			//   
0b01010000,0b01010000);			//FL.SOST

__EEPROM_DATA(10,0,11,5,6,11,3,7);	//   
__EEPROM_DATA(4,11,0,4,11,0,5,11);	//

#define ADTELEFEEP	0x18	//   "  "
//---------------------------------------------------------------------------
//    
void init(void);			// 
void Indic_ra(void);		//  
void Nastro_par(char par);	// 
void Klava (void);			// 
void portcon(void);			//    
void readdata(void);		// 
void savedata(void);		// 

void AutoExitNas(void);		//    
//void bigstEEPROM(void);		//   EEPROM  

void sleep(void);//  
void time(char hour, char minutes);// 
void budilnik (void); // 
void regulyarkost(void);//  

// ch-4010  - oC   - 1,0 
const char model[]={cc,ch,cM,c4,c0,c2,c0,cM,co,cC,cM,c1,c8t,0};
//         056-374-04-05	
//const char telefon[]={cP,ch,co,cn,cE,0};

volatile bit te00,te01,te02,te03,
BU00,BU01,BU02,BU03;//    0-3  

volatile char tiBR00,tiBR01,tiBR02,tiBR03,// ,   
rPORTB; //  

bit KLNAJ,	//  
BONIN,		//    
FUNPAR,		// 0 -  /1 -   
IMENE,		//   ,      ,  
INIRES;		//   	

bit PASSW1,PASSW2,PASSW3; // 
char anim,				//    
function,				// 
uroven; 				// 
#define COLFUN1 9		//    1
#define COLFUN2 4		//    2
#define COLFUN3 3		//    3
//--------------------------------------------------------------------
//   
char timer_avt,timer_avtper;
//--------------------------------------------------------------------
//char teleaddr,poslsim;	//     
//--------------------------------------------------------------------
//    
unsigned int password_in;
unsigned char repassword, password_uc;

//--------------------------------------------------------------------
volatile char

timer_uderj,			//   
tim1sek,				//     1 sek 
tim1mim,				//     1  
tim1hours, 				//  1 hours
tim1day, 				//  1 day
signal, 				//    
timauexit; 				//      


volatile bit AUTOEXIT; 	// flag    

char acpyar,acpyarp;
int timery;
volatile char tim500;
//--------------------------------------------------------------------
//char datchikind;
bit napr;							// 
char temper;						//   	
bit budON1,budON2,budON3,budON4;
//--------------------------------------------------------------------
volatile unsigned char seconds,minutes,hour; 	//   
volatile unsigned char secondst,minutest,zapusktime; 		//  
volatile unsigned char minutesS,secondsS;	//
unsigned char minutestP; // 
volatile unsigned char timerAlarmBeep;
unsigned char minutes1,hour1,minutes2,hour2,minutes3,hour3,minutes4,hour4; // 
volatile bit BEEPALARM; //   
volatile bit PUSK_STOP; //    
//--------------------------------------------------------------------
//      EEPROM
int deepr_in[2];
char deepr_ch[8];

#define pasvr 		deepr_in[0] //   1
	
#define rerareg01	deepr_ch[0]	//    1
#define rerareg02	deepr_ch[1]	//    2
#define rerareg03	deepr_ch[2]	//    3
#define rerareg04	deepr_ch[3]	//    4

#define povvklcomp	deepr_ch[4]//   .
#define tito		deepr_ch[5]//     45 .
#define titotek		deepr_ch[6]//    

#define POWER		RA3			//    

#define PASSWU2		0x73a2		//  2 
#define PASSWU3	 	0xadec		//  3 
#define PASSWU1	 	0x2ab7		//   1 
#define PASSWMA 	0x2863		//   
//#define PASSWMA 	0x1000		//   


//  
volatile union 
{
    struct
	{
        unsigned	F_STOP		:1;//   . 
        unsigned	ON1			:1;// 
        unsigned	ON2			:1;// 
        unsigned	ON3			:1;// 
        unsigned	ENPA		:1;//   1 . 
        unsigned	DISTO		:1;// 
        unsigned	ERDT		:1;//   
        unsigned	ERDA		:1;//  
    };
    struct 
	{
        unsigned 	SOST		:8;
    };
}FL;
//--------------------------------------------------------------------


//   
//--------------------------------------------------------------------
void main(void)
{
//--------------------------------------------------------------------
	NOP(); 							//
	CLRWDT(); 						//   +++++++++++++++++++++- 
	init();							// 
	zaderj(50);						// 
//--------------------------------------------------------------------
	yarcost=10;
//--------------------------------------------------------------------
	bigstroka(&model[0]); 			// 	
//--------------------------------------------------------------------
	readdata();						//  
//----------------------------
	yarcost=1;
	PASSW1=0;
	PASSW2=0;
	PASSW3=0;

//--------------------------------------------------------------------

//====================================================================
	//   
while(1)
	{
//--------------------------------------------------------------------
//   
//----------------------------------
//  
		CLRWDT(); 				//    +++++++++++++++++++++- 
//----------------------------------
		if(!POWER)sleep();		//  
//----------------------------------
		portcon(); 				//    
		budilnik ();			// 
		AutoExitNas();			//     

//----------------------------------
		Indic_ra();				//   
//----------------------------------
		Klava (); 				//   
//----------------------------------
		regulyarkost();			//  

	}
	
}//end programm==========================================================



void regulyarkost(void)//  
{
	if(GO==0)
	{
		acpyar=ADRESH;
		acpyar=(255-acpyar)/24;// 
		if(acpyar==0)acpyar=1;
		else if(acpyar>MAXYAR)acpyar=10;
		GO=1;//   
	    //        " "
		if(acpyar^acpyarp && timery)timery--;
		else 
		{
		   acpyarp=acpyar;
		   timery=4000;
		}
	    yarcost=acpyarp;
	}
 	
}//




//     
void AutoExitNas(void)//    
{
	if (AUTOEXIT==1)
	{
		AUTOEXIT=0;	// 	
		function=0;	// 
		uroven=0;	//  
		BONIN=1;	//  
		anim=2; 	// 

		PASSW1=0; 	//     
		PASSW2=0;
		PASSW3=0;
		FUNPAR=0;						
		if (IMENE==1)
		{
			savedata();	//  
			IMENE=0;	//  
		}	
	}
}//--------------------------------------------------------------------	



//      EEPROM
//      
#define dataint		2
#define datachar	7
//           
//      ,      .
//--------------------------------------------------------------------
void readdata(void)		// 
{
	//   int
char a,bufer0,bufer1,eadr;
	while (WR) continue;
	eadr=0;
	for(a=0;a<dataint;a++)
	{
		bufer0 = EEPROM_READ(eadr);
		eadr++;
		bufer1 = EEPROM_READ(eadr);
		eadr++;
		if (bufer0==bufer1)	deepr_in[a]=bufer0;
		else if(bufer0<bufer1)	deepr_in[a]=bufer0;
		else deepr_in[a]=bufer1;
		
		bufer0 = EEPROM_READ(eadr);
		eadr++;
		bufer1 = EEPROM_READ(eadr);
		eadr++;
		
		if (bufer0==bufer1)	deepr_in[a]+=bufer0<<8;
		else if(bufer0<bufer1)	deepr_in[a]+=bufer0<<8;
		else deepr_in[a]+=bufer1<<8;
	}	
	//   chat
	for(a=0;a<datachar;a++)
	{
		bufer0 = EEPROM_READ(eadr);
		eadr++;
		bufer1 = EEPROM_READ(eadr);
		eadr++;
		if (bufer0==bufer1)	deepr_ch[a]=bufer0;
		else if(bufer0<bufer1)	deepr_ch[a]=bufer0;
		else deepr_ch[a]=bufer1;
	}
	//   struct
		bufer0 = EEPROM_READ(eadr);
		eadr++;
		bufer1 = EEPROM_READ(eadr);
		eadr++;
		if (bufer0==bufer1)	FL.SOST=bufer0;
		else if(bufer0<bufer1)	FL.SOST=bufer0;
		else FL.SOST=bufer1;
	
}//--------------------------------------------------------------------	



void savedata(void)		// 
{
	//   int
char a,eadr;
		while (WR) continue;
		eadr=0;
	for(a=0;a<dataint;a++)
	{
		eeprom_write(eadr,deepr_in[a]);
		while (WR) continue;
		eadr++;
		eeprom_write(eadr,deepr_in[a]);
		while (WR) continue;	
		eadr++;
		eeprom_write(eadr,deepr_in[a]>>8);
		while (WR) continue;		
		eadr++;
		eeprom_write(eadr,deepr_in[a]>>8);
		while (WR) continue;
		eadr++;
	}	
	//   int
	for(a=0;a<datachar;a++)
	{
		eeprom_write(eadr,deepr_ch[a]);
		while (WR) continue;
		eadr++;
		eeprom_write(eadr,deepr_ch[a]);
		while (WR) continue;
		eadr++;
	}
	//   struct
		eeprom_write(eadr,FL.SOST);
		while (WR) continue;
		eadr++;
		eeprom_write(eadr,FL.SOST);
}//--------------------------------------------------------------------	







void Klava (void)
{
char	eadr;
//--------------------------------------------------------------------
		if(BU00)//   1
		{
			if(!KLNAJ)	// -    ?
			{
				timauexit=120;
				KLNAJ=1; //  
				BONIN=1;				
		//	if(++yarcost>10)yarcost=1;
		//		bigstroka(&model[0]); 			// 	
				if(FUNPAR==0)
				{
					anim=3;
					if(uroven==0)
					{
						if(temper==3)
						{
							PUSK_STOP=0;
							secondsS=0;
							minutesS=0;
							anim=0;
						}							
						else
						{	
							BEEPALARM=0;
							zapusktime=3;
							if(minutest>10)
							{
								minutest=minutest-5;
								secondst=0;
								minutestP=minutest;
							}
							else
							{
								minutest=0;
								secondst=0;
								RELE2=0;
							}	
							function=0;
							if(temper==0&&minutest&&secondst)
							{
								temper=1;//   
								anim=2;
							}
							else if(temper==2&&minutest&&secondst)
							{
								temper=1;//   
								anim=1;
							}
							else if(temper==1&&!minutest&&!secondst)
							{
								temper=0;//   
								anim=1;
							}	
							else anim=0;
						}	
					}
					else if(uroven==2)
					{
						if(--function==0xFF)function=COLFUN1-1;//     -  
					}
					else if(uroven==4)
					{
						if(--function==0xFF)function=COLFUN2-1;//     -  
					}
					else if(uroven==6)
					{
						if(--function==0xFF)function=COLFUN3-1;//     -  
					}
				}
				else
				{
					Nastro_par(0);//  
				}
			}
		}
//--------------------------------------------------------------------
		else
		if(BU01)//   2
		{
			if(!KLNAJ)	// -    ?
			{
				timauexit=120;
				KLNAJ=1; //  
				BONIN=1;				

				if(FUNPAR==0)
				{
					anim=4;				
					if(uroven==0)
					{
						if(temper==3)
						{
							PUSK_STOP=!PUSK_STOP;
							anim=0;
						}							
						else
						{
							if(BEEPALARM)
							{
								minutest=minutestP;
								RELE2=1;
								BEEPALARM=0;
								anim=0;
							}	 
							else
							{
								RELE2=1;
								BEEPALARM=0;
								zapusktime=5;
								if(minutest<90)
								{
									if(minutest<5)minutest++;
									else minutest=minutest+5;
									secondst=0;
									if(minutest>90)minutest=90;
									napr=1;
									minutestP=minutest;
								}
								function=0;
								if(temper==0)
								{
									temper=1;//   
									anim=2;
									napr=1;
								}
								else if(temper==2)
								{
									temper=1;//   
									anim=1;
									napr=0;
								}
								else anim=0;
							}
						}		
						timer_uderj=50; //    50== 5 
					}
					else if(uroven==2)
					{
						if(++function==COLFUN1)function=0;//     -  
					}
					else if(uroven==4)
					{
						if(++function==COLFUN2)function=0;//     -  
					}
					else if(uroven==6)
					{
						if(++function==COLFUN3)function=0;//     -  
					}
				}
				else
				{
					Nastro_par(1);//  
				}
			}			
		}
//--------------------------------------------------------------------
		else
		if(BU02)//   3
		{
			if(!KLNAJ)	// -    ?
			{
				timauexit=120;
				KLNAJ=1; //  
				if(uroven==0||(function==0 && (uroven==2 || uroven==4)) || ((PASSW1==1 && uroven==1) || (PASSW2==1 && uroven==3) || (PASSW3==1 && uroven==5)))
				{
					if(FL.ENPA==1 && uroven==0 || (PASSW2==1 && uroven==2) || (PASSW3==1 && uroven==4))uroven++;//  1 
					anim=1; 			// 
					uroven++;
					BONIN=1;			//  
					FUNPAR=0;			//  
				}
				else if(!(function==0 && uroven==6))//    3  
				{
//      					
					BONIN=1;			//  	
					FUNPAR=!FUNPAR;		//  
					if(!FUNPAR) anim=2; //  
					else anim=1; 		//  	
				}	
			}
		}						
//--------------------------------------------------------------------
		else
		if(BU03)//   4
		{
			if(!KLNAJ)			// -    ?
			{
				timauexit=120;
				KLNAJ=1; 		// 

				if(uroven>0 && FUNPAR==0)    //       
				{
					function=0;
					if (--uroven!=0 && uroven!=2 && uroven!=4 && uroven!=6 )uroven--;	//  
					BONIN=1;	//  
					anim=2; 	// 
	//      
					if (uroven==0 && IMENE==1)
					{
						IMENE=0;
						savedata();
					}			
					if (uroven==0)
					{
						PASSW1=0; //     
						PASSW2=0;
						PASSW3=0;
					}	
			
				}
				else if(uroven>0)
				{
					FUNPAR=0;	//  
					BONIN=1;	//  
					anim=2; 	// 
				}
				else
				{
					BEEPALARM=0;
					if(temper==0)
					{
						loading(ct,ci,cN,cE,2);
						zaderj(25);	// 	
						temper=1;//   
						anim=2;
						napr=1;	
					}
					else if(temper==1 && napr==1)
					{
						loading(c5,ct,co,cP,2);
						zaderj(25);	// 
						temper=2;//   
						anim=2;
					}
					else if(temper==2 && napr==1)
					{
						loading(cc,cl,co,cc,2);
						zaderj(25);	// 
						temper=0;//   
						anim=2;
					}
				}	
			}	
		}
//--------------------------------------------------------------------
		else
		{
		//   
			KLNAJ=0;			//   
			timer_avt=250;		//    
			timer_avtper = 150;	//   
		}
//--------------------------------------------------------------------
		//        
		
		//   BU01  5 
		if(BU01 && KLNAJ && uroven==0 && timer_uderj==0)//   2  
		{

			FL.ERDT=0; 
			eadr=0x36;	
		//   struct
			eeprom_write(eadr,FL.SOST);
			while (WR) continue;
			eadr++;
			eeprom_write(eadr,FL.SOST);
			KLNAJ=0;
			timer_uderj=50;

		}	
//--------------------------------------------------------------------
		//
		if (timer_avt==0 && uroven!=0)
		{
			KLNAJ=0; //      	 +------   
			if (timer_avtper != 10)--timer_avtper; //   
			timer_avt=timer_avtper; //   
		}								
}//--------------------------------------------------------------------		






//   
void Nastro_par(char par)
{
	IMENE=1;

	if (uroven==1 || uroven==3 || uroven==5)//     
	{
		if(!par) 
		{
			repassword++;
			repassword=(0x0F & repassword);			
			if (password_uc==1)
			{
				password_in&=0b0000111111111111;				
				password_in|=repassword<<12;
			}
			else if (password_uc==2)
			{
				password_in&=0b1111000011111111;				
				password_in|=repassword<<8;
			}	
			else if (password_uc==3)
			{
				password_in&=0b1111111100001111;				
				password_in|=repassword<<4;
			}
			else if (password_uc==4)					
			{
				password_in&=0b1111111111110000;				
				password_in|=repassword;
			}
		}
		else
		{
			if (++password_uc>4)password_uc=1;
			repassword=0;
		}	
	}	
//--------------------------------------------------------------------
	else if (uroven==2)//     
	{
			switch (function)
			{
		//--------------------------------------		
				case 1://   1
 				if(par) 
 				{
	 				minutes1++;
	 				if(minutes1>=60)
	 				{
		 				minutes1=0;
		 				hour1++;
		 				if(hour1>=24)
		 				{
			 				hour1=0;
			 			}	
		 			}	
				}
 				else
 				{
	 				minutes1--;
	 				if(minutes1==255)
	 				{
		 				minutes1=59;
		 				hour1--;
		 				if(hour1==255)
		 				{
			 				hour1=23;
			 			}	
		 			}
	 			}	
		    break;
		//--------------------------------------
				case 2://   2
 				if(par) 
 				{
	 				minutes2++;
	 				if(minutes2>=60)
	 				{
		 				minutes2=0;
		 				hour2++;
		 				if(hour2>=24)
		 				{
			 				hour2=0;
			 			}	
		 			}	
				}
 				else
 				{
	 				minutes2--;
	 				if(minutes2==255)
	 				{
		 				minutes2=59;
		 				hour2--;
		 				if(hour2==255)
		 				{
			 				hour2=23;
			 			}	
		 			}
	 			}	
		    break; 
		//--------------------------------------
				case 3://   3
 				if(par) 
 				{
	 				minutes3++;
	 				if(minutes3>=60)
	 				{
		 				minutes3=0;
		 				hour3++;
		 				if(hour3>=24)
		 				{
			 				hour3=0;
			 			}	
		 			}	
				}
 				else
 				{
	 				minutes3--;
	 				if(minutes3==255)
	 				{
		 				minutes3=59;
		 				hour3--;
		 				if(hour3==255)
		 				{
			 				hour3=23;
			 			}	
		 			}
	 			}	
		    break; 
		//--------------------------------------
				case 4://   4
 				if(par) 
 				{
	 				minutes4++;
	 				if(minutes4>=60)
	 				{
		 				minutes4=0;
		 				hour4++;
		 				if(hour4>=24)
		 				{
			 				hour4=0;
			 			}	
		 			}	
				}
 				else
 				{
	 				minutes4--;
	 				if(minutes4==255)
	 				{
		 				minutes4=59;
		 				hour4--;
		 				if(hour4==255)
		 				{
			 				hour4=23;
			 			}	
		 			}
	 			}	
		    break; 
		//--------------------------------------
			case 5://    1.
				if(par) 
				{
 					if(rerareg01<1)rerareg01++;
				}
				else
				{
 					if(rerareg01>0)rerareg01--;
 				}	
	    break;
		//--------------------------------------
			case 6://    2.
				if(par) 
				{
 					if(rerareg02<1)rerareg02++;
				}
				else
				{
 					if(rerareg02>0)rerareg02--;
 				}	
	    break;
		//--------------------------------------
			case 7://    3.
				if(par) 
				{
 					if(rerareg03<1)rerareg03++;
				}
				else
				{
 					if(rerareg03>0)rerareg03--;
 				}	
	    break;
		//--------------------------------------
			case 8://    4.
				if(par) 
				{
 					if(rerareg04<1)rerareg04++;
				}
				else
				{
 					if(rerareg04>0)rerareg04--;
 				}	
	    break;
		//--------------------------------------
			}
	}
	else if (uroven==4)//     
	{
		switch (function)
		{
	//--------------------------------------
			case 1://  
				if(par) 
				{
 					minutes++;
 					if(minutes>=60)
 					{
	 					minutes=0;
	 					hour++;
	 					if(hour>=24)
	 					{
		 					hour=0;
		 				}	
	 				}	
				}
				else
				{
 					minutes--;
 					if(minutes==255)
 					{
	 					minutes=59;
	 					hour--;
	 					if(hour==255)
	 					{
		 					hour=23;
		 				}	
	 				}
 				}	
	    break;
	//--------------------------------------
			case 2://  
				TMR1H = 0;
				TMR1L = 0;
				if(seconds>=30)
				{
					minutes++;
					seconds=0;
				}
				else	seconds=0;
	    break;
	//--------------------------------------
			case 3://   1.
				FL.ENPA=!FL.ENPA;	
	    break;
	//--------------------------------------
		}
	}
	else if (uroven==6)//     
	{
		switch (function)
		{
	//--------------------------------------
			case 1://   1.
		if(!par) 
		{
			repassword++;
			repassword=(0x0F & repassword);			
			if (password_uc==1)
			{
				pasvr&=0b0000111111111111;				
				pasvr|=repassword<<12;
			}
			else if (password_uc==2)
			{
				pasvr&=0b1111000011111111;				
				pasvr|=repassword<<8;
			}	
			else if (password_uc==3)
			{
				pasvr&=0b1111111100001111;				
				pasvr|=repassword<<4;
			}
			else if (password_uc==4)					
			{
				pasvr&=0b1111111111110000;				
				pasvr|=repassword;
			}
		}
		else
		{
			if (++password_uc>4)password_uc=1;
			repassword=0;
		}	
	    break;
	//--------------------------------------
			case 2://  . 
			if(par) 
			{
				INIRES=1;
				

				pasvr=0x4433;		// 4433   1
				rerareg01=0;		//    1
				rerareg02=0;		//    2
				rerareg03=0;		//    3
				rerareg04=0;		//    4
				FL.SOST =0b01010000;			//  
				savedata();	//  
			}
	    break;
	//--------------------------------------
		}	
	}		
}//






//=========================================================================
//------------------------- --------------------------------
void Indic_ra(void)
{

//--------------------------------------------------------------------
	if (uroven==0)      //     
	{
		switch (function)//    
		{	
	//--------------------------------------
		case 0://   
			//--------------------------------------		
			switch (temper)
			{
				case 0://  
					time(hour,minutes);
					TOCHm2=1;
					loading(tysc,sotn,dest,edin,anim);
					anim=0;
	   			break;
				case 1://  
					time(minutest,secondst);
					TOCHm2=0;
					if(minutest || secondst)loading(tysc,sotn,dest,edin,anim);
					else loading(cM,cM,cM,cM,anim);
					anim=0;
	   			break;
				case 2://  
					time(minutesS,secondsS);
					TOCHm2=0;
					loading(tysc,sotn,dest,edin,anim);
					anim=0;
	   			break;
	   		}			
	    break;  	
	//--------------------------------------
		case 1://  
			if(FL.ERDT)						//     
			{
				loading(cE,cr,cM,cL,anim); 	//
			}
			else 
			{
				loading(cn,co,cA,cL,anim); 	//  
			}
				zaderj(100);				// 
	    break;  	
	//--------------------------------------
		}
		function=0;	
	}
//--------------------------------------------------------------------
	else if(uroven==1) // 
	{
		if(!BONIN) return;	//   
		BONIN=0; 			//    
		if(!FUNPAR)//   0-/1-
		{
			if (PASSW1==0)loading(cP,cA,c5,c5,anim);	//  
			else loading(cM,cd,cE,cM,anim);			//    
			password_in=0;
			password_uc=1;
			repassword=0;
		}
    	else
    	{
			bin_HEX (password_in, password_uc);
			loading(tysc,sotn,dest,edin,anim); //  		
			anim=0;
			if(password_in==pasvr || password_in==PASSWMA  || password_in==PASSWU1)
			{
				PASSW1=1;
				FUNPAR=0;
			}	
		} 	
	}			
//--------------------------------------------------------------------
	else if(uroven==2) //  1 
	{
		if(!BONIN) return;	//   
		BONIN=0; 			//    
		switch (function)	// 
		{
	//--------------------------------------
		case 0://   -    2
			loading(c_,cU,c1,c_,anim);		//  
		break; 
	//--------------------------------------
	 	case 1://  1
			if(!FUNPAR)//   0-/1-
			{
				loading(cb,cu,cd,c1,anim);	//  
			}
	    	else	time(hour1,minutes1);
			goto ind_timeus; 	
	//-------------------------------------- 	
	 	case 2://  2
			if(!FUNPAR)//   0-/1-
			{
				loading(cb,cu,cd,c2,anim);	//  
			}
	    	else	time(hour2,minutes2);
			goto ind_timeus;	
	//-------------------------------------- 
	 	case 3://  3
			if(!FUNPAR)//   0-/1-
			{
				loading(cb,cu,cd,c3,anim);	//  
			}
	    	else	time(hour3,minutes3);
			goto ind_timeus;	
	//--------------------------------------		 	
	 	case 4://  4
			if(!FUNPAR)//   0-/1-
			{
				loading(cb,cu,cd,c4,anim);	//  
			}
	    	else	time(hour4,minutes4);
ind_timeus:
		if(FUNPAR)
		{
			loading(tysc,sotn,dest,edin,anim); //  		
			anim=0;
		}
	    break;
	//--------------------------------------
		case 5://   1. 
			if(!FUNPAR)//   0-/1-
			{
				loading(cr,cr,cb,c1,anim);	//  
			}
	    	else
	    	{
				switch (rerareg01)
				{
				//--------------------------------------
					case 0:
	  			  	loading(cM,co,cF,cM,anim); //   
	  			  	break;
				//--------------------------------------
					case 1:
	  			  	loading(cM,co,cn,cM,anim); //   
	  			  	break;  	
				//--------------------------------------
				}
				anim=0;
			} 	
	    break;
	//--------------------------------------
		case 6://   2. 
			if(!FUNPAR)//   0-/1-
			{
				loading(cr,cr,cb,c2,anim);	//  
			}
	    	else
	    	{
				switch (rerareg02)
				{
				//--------------------------------------
					case 0:
	  			  	loading(cM,co,cF,cM,anim); //   
	  			  	break;
				//--------------------------------------
					case 1:
	  			  	loading(cM,co,cn,cM,anim); //   
	  			  	break;  	
				//--------------------------------------
				}
				anim=0;
			} 	
	    break;
	//--------------------------------------
		case 7://   3. 
			if(!FUNPAR)//   0-/1-
			{
				loading(cr,cr,cb,c3,anim);	//  
			}
	    	else
	    	{
				switch (rerareg03)
				{
				//--------------------------------------
					case 0:
	  			  	loading(cM,co,cF,cM,anim); //   
	  			  	break;
				//--------------------------------------
					case 1:
	  			  	loading(cM,co,cn,cM,anim); //   
	  			  	break;  	
				//--------------------------------------
				}
				anim=0;
			} 	
	    break;
	//--------------------------------------
		case 8://   4. 
			if(!FUNPAR)//   0-/1-
			{
				loading(cr,cr,cb,c4,anim);	//  
			}
	    	else
	    	{
				switch (rerareg04)
				{
				//--------------------------------------
					case 0:
	  			  	loading(cM,co,cF,cM,anim); //   
	  			  	break;
				//--------------------------------------
					case 1:
	  			  	loading(cM,co,cn,cM,anim); //   
	  			  	break;  	
				//--------------------------------------
				}
				anim=0;
			} 	
	    break;
	//--------------------------------------
	 	}	
	}
//--------------------------------------------------------------------
	else if(uroven==3) // 
	{
		if(!BONIN) return;	//   
		BONIN=0; 			//    
			if(!FUNPAR)//   0-/1-
			{
				if (PASSW2==0)loading(cP,cA,c5,c5,anim);
				else loading(cM,cd,cE,cM,anim);			//  
				password_in=0;
				password_uc=1;
				repassword=0;
			}
	    	else
	    	{
				bin_HEX (password_in, password_uc);
				loading(tysc,sotn,dest,edin,anim); //  		
				anim=0;
				if(password_in==PASSWU2 || password_in==PASSWMA)
				{
					PASSW2=1;
					FUNPAR=0;
				}	
			} 	
	}
//--------------------------------------------------------------------
	else if(uroven==4) //  2 
	{
		if(!BONIN) return;//   
		BONIN=0; //    
		switch (function)
		{
	//--------------------------------------
		case 0://   -    3
				loading(c_,cU,c2,c_,anim);	//  
		break; 
	//--------------------------------------
	 	case 1:// 
			if(!FUNPAR)//   0-/1-
			{
				loading(cc,cl,co,cc,anim);	//  
			}
	    	else
	    	{
		    	time(hour,minutes);
				loading(tysc,sotn,dest,edin,anim); //  		
				anim=0;	 			
			}
	    break;
	//--------------------------------------
		case 2://  
			if(!FUNPAR)//   0-/1-
			{
				loading(c5,ci,cn,ch,anim);	//  
			}
	    	else
	    	{
		    	time(0,seconds);
				loading(c_,c_,dest,edin,anim); //  		
				anim=0;	
			} 	
	    break;  	
	//--------------------------------------
		case 3://  1 . 
			if(!FUNPAR)//   0-/1-
			{
				loading(cd,cE,cP,c1,anim);	//  
			}
	    	else
	    	{
				if(!FL.ENPA)loading(cE,cn,cb,cl,anim); //  		
				else loading(cd,ci,cS,cA,anim); 
				anim=0;
			} 	
	    break;  	
	//--------------------------------------
		}
	}
//--------------------------------------------------------------------
	else if(uroven==5) // // 
	{
		if(!BONIN) return;	//   
		BONIN=0; 			//    
			if(!FUNPAR)//   0-/1-
			{
				if (PASSW3==0)loading(cP,cA,c5,c5,anim);
				else loading(cM,cd,cE,cM,anim);			//  
				password_in=0;
				password_uc=1;
				repassword=0;
			}
	    	else
	    	{
				bin_HEX (password_in, password_uc);
				loading(tysc,sotn,dest,edin,anim); //  		
				anim=0;
				if(password_in==PASSWU3 || password_in==PASSWMA)
				{
					PASSW3=1;
					FUNPAR=0;
				}	
			} 	
	}
//--------------------------------------------------------------------
	else if(uroven==6) //  3 
	{
		if(!BONIN) return;//   
		BONIN=0; //    
		switch (function)
		{
	//--------------------------------------
			case 0://   
				loading(c_,cU,c3,c_,anim);	//  
			    break; 
	//--------------------------------------
			 case 1://    1 
			if(!FUNPAR)//   0-/1-
			{
				loading(cn,cP,cu,c1,anim);	//  
				password_uc=1;
				repassword=0;
			}
	    	else
	    	{
				bin_HEX (pasvr, password_uc);
				loading(tysc,sotn,dest,edin,anim); //  		
				anim=0;
			} 	
	    break;  	
	//--------------------------------------
			 case 2://   . 
			if(!FUNPAR)//   0-/1-
			{
				loading(c2,cA,cu,cd,anim);	//  
				INIRES=0;
			}
	    	else
	    	{
				if(INIRES)loading(ci,cn,ci,ct,anim); //  		
				else loading(c_,cY,cE,c5,anim); 
				anim=0;
			} 	
	    break;  	
	//--------------------------------------
		 //	default:
		}
	}
}//--------------------------------------------------------------------














//    	
void portcon(void)	
{
#define ZADKLAV 1 //     
//--------------------------------------------------------------------
			if(!(rPORTB & 0b10000000))//   
			{
				if(te03==1)	
				{
					te03=0;
					tiBR03=ZADKLAV;
				}
				if(tiBR03==0)BU03=1;
			}
			else
			{
				te03=1;
				BU03=0;
			}
//-------------------------------------------------------
			if(!(rPORTB & 0b01000000))//   
			{
				if(te02==1)	
				{
					te02=0;
					tiBR02=ZADKLAV;
				}
				if(tiBR02==0)BU02=1;
			}
			else
			{
				te02=1;
				BU02=0;
			}
//-------------------------------------------------------
			if(!(rPORTB & 0b00100000))//   
			{
				if(te01==1)	
				{
					te01=0;
					tiBR01=ZADKLAV;
				}
				if(tiBR01==0)BU01=1;
			}
			else
			{
				te01=1;
				BU01=0;
			}
//-------------------------------------------------------
			if(!(rPORTB & 0b00010000))//   
			{
				if(te00==1)	
				{
					te00=0;
					tiBR00=ZADKLAV;
				}
				if(tiBR00==0)BU00=1;
			}
			else
			{
				te00=1;
				BU00=0;
			}
}//--------------------------------------------------------------------















//--------------------------------------------------------------------
// 
void interrupt my_isr(void) //
{
	// , , 
	if(TMR1IF)
	{
	//	TMR1H = 0x80;//    4  
	//	TMR1L = tochnoct;// 
		TMR1IF=0;
		//  
		seconds=seconds+4;
		if ( seconds >= 60 )
		{
			seconds = 0;
			minutes++;
			if ( minutes >= 60 )
			{
				minutes = 0;
				hour++;
				if ( hour >= 24 )
				{
					hour = 0;
				}
			}
		}			
	}


	//     
	if(TMR0IF&&POWER)
//	if(TMR0IF)
		{
		TMR0IF=0;	//      TMR0
	//----------------------------------------------
		// 	3906,25 Hz	start
		indic();		// 
		if(--tim500==0)
		{
			tim500=8;
			if (timer_avt!=0 && KLNAJ==1)--timer_avt; //         
		}
	//----------------------------------------------
		//     
#ifndef CATOD//    indic_4led.h	
		TRISC |= 0b00001111;		//    
#endif//
		TRISB=0xFF;		// 
		_delay(40);		//    
		rPORTB=PORTB;	// 
		TRISB=0;		// 
#ifndef CATOD
		TRISC &= 0b11110000;		//    
#endif//
	//----------------------------------------------
		if(--tim10gc==0)
		{
			tim10gc=391;
			//  10 .------------------------
	//    
			if(tiBR00!=0)tiBR00--;
			if(tiBR01!=0)tiBR01--;
			if(tiBR02!=0)tiBR02--;
			if(tiBR03!=0)tiBR03--;
			//--------------------------------------
/*
			//---   ----------------------------
			if(CONV==1)
			{
				if(convert--==0)
				{
					convert=9; 	// 8-9    0.75Cek
					CONV=0;		//
				}
			}*/
			//--------------------------------------
			if(timer_uderj!=0)timer_uderj--;//   
			//--------------------------------------
	
			//----   ------------------------					
				if(BEEPALARM)
				{
					if(--timerAlarmBeep==0)
					{
						switch(signal)
						{
							case 0:	
						    	signal=1;
						    	timerAlarmBeep=2;
						    	RELE1=1;
						    break;
							case 1:	
						    	signal=2;
						    	timerAlarmBeep=1;
						    	RELE1=0;
						    break;
							case 2:	
						    	signal=3;
						    	timerAlarmBeep=1;
						    	RELE1=1;
						    break;
							case 3:	
						    	signal=4;
						    	timerAlarmBeep=1;
						    	RELE1=0;
						    break;
							case 4:	
						    	signal=5;
						    	timerAlarmBeep=1;
						    	RELE1=1;
						    break;
							case 5:	
						    	signal=0;
						    	timerAlarmBeep=60;
						    	RELE1=0;
						    break;
						}    					    			    	
					}
				}			
				else
				{	//  					
					timerAlarmBeep=1;
					RELE1=0;
				}
			
			//--------end period 10 .-----------------------------
			if(--tim2gc==0)
			{
				tim2gc=5;
				//  2 .-------------------
	
				//-----  ( -------------------------
					B_MIG = !B_MIG; //  :)
				
				 //      
					if(--timauexit==0 && uroven!=0)
					{
						AUTOEXIT=1;//     
					}
	
// end period 2 .------------------------------			
				if(--tim1sek==0)
				{
					tim1sek=2;
//  1 sek.-----------------------------
					if(zapusktime>0)zapusktime--;//    
					if(zapusktime==0 && (secondst>0 || minutest>0))
					{					
		 				secondst--;
		 				if(secondst==255)
		 				{
			 				secondst=59;
			 				minutest--;
			 			}		
						if(secondst==0 && minutest==0)
						{
							BEEPALARM=1;
							RELE2=0;
						}	
					}
//------------------  -----------------
					if(PUSK_STOP)
					{					
		 				secondsS++;
		 				if(secondsS>=60)
		 				{
			 				secondsS=0;
			 				minutesS++;
			 			}		
						if(secondsS==59 && minutesS==99)
						{
			 				BEEPALARM=1;
			 				secondsS=0;
			 				minutesS=0;
						}
					}
//-----------------------------------------------
// end period 1 sek -----------------------------			
				}//--------end period 1 sek.-----------------------------
			}//--------end period 2 Hz.-----------------------------			
		}//--------end period 10 Hz.-----------------------------	
	}
	else
	{
		TMR0IF=0;	//      TMR0	
		LATA=0;	//  
		LATB=0;
		LATC=0;
	}		
}//end_interrupt----------------------------------------------------------------





//================================================================================
void init(void)//  
{
//-----------------------------------------
	CLRWDT();				//   
//-----------------------------------------
//   	
	WDTCON = 0b00010110;
//	  	         |||||+--     (   -    )
//			     +++++--- 01011 = 1:65536 ( 2s ) (  ) 
//-----------------------------------------
//     8*4=32 
	OSCCON=0b11110000;		//
//	 	     ||||||||
//			 ||||| ++-- SCS<1:0>	  (  PLL) 
//			 |++++----- IRCF<3:0>	 8  
//			 +--------- SPLLEN	 0-, 1-
//-----------------------------------------
	CLRWDT();				//   
//-----------------------------------------
//  
//     ( )
// 	APFCON0
// 	APFCON1
//	 PORTA
	ANSELA	= 0b00000100; 	//  RA2   
	PORTA	= 0b00000000;	// 
	LATA	= 0b00000000; 	//    
	TRISA	= 0b00110100; 	//  2 
//   	
	WPUA	= 0b00000000; 	//  		
//         ( TTL)
//	INLVLA
//	 PORTB
	ANSELB	= 0b00000000; 	//   
	PORTB	= 0b00000000;	// 
	LATB	= 0b00000000; 	//    	
	TRISB	= 0b00000000; 	//   
//   	
	WPUB	= 0b11110000; 	//        
//         (  TTL)
//	INLVLB
//	 PORTC
	ANSELC	= 0b00000000; 	//   
	PORTC	= 0b00000000;	// 
	LATC	= 0b00000000; 	//    	
	TRISC	= 0b00000000; 	//   
//   	
	WPUC	= 0b00000000; 	//  
//         (  ST)
//	INLVLC
//-----------------------------------------	
//  
	ADCON0	= 0b00001001; 	// 
//              |||||||+-- ADON:  
//              ||||||+--- GO/DONE:  
//              |+++++---- CHS<4:0>: Analog Channel Select bits
//              +--------- :   "0"
	ADCON1	= 0b01100000; 	// 
//              ||||||++-- ADPREF<1:0>:  
//              |||||+---- ADNREF:  
//              ||||+----- Unimplemented:
//              |+++------ ADCS<2:0>: Analog Channel Select bits
//              +--------- ADFM: A/D Result Format Select bit
//-----------------------------------------	
//  OPTION_REG
//  TIMER0      
//   
	OPTION_REG	=	0b00000010;
//					  |||||+++- PS<2:0>:   TIMER0 1 : 16
//					  ||||+---- PSA:     Timer0
//					  |||+----- TMR0SE:    0->1
//					  ||+------ TMR0CS:   (FOSC/4)
//					  |+------- INTEDG: 0    RB0/INT   
//					  +-------- WPUEN:    
//-----------------------------------------	
// 
// 
	tim10gc=40;
	tim2gc=5;
	tim1sek=2;
	tim1mim=120;
	tim1hours=60;
	tim1day=24;
//-----------------------------------------	
//   1
// TMR1CS<1:0> T1CKPS<1:0> T1OSCEN T1SYNC  TMR1ON
		T1CON	=	0b10011101;
//					  |||||||+- TMR1ON: 1 -  
//					  ||||||+-- :   "0"
//					  |||||+--- T1SYNC: 1 -     
//					  ||||+---- T1OSCEN: 1 - LP  - Timer1 
//					  ||++----- T1CKPS<1:0>: 11 - 1:2  
//					  ++------- TMR1CS<1:0>: 10 -     1  
//		T1GCON	=	0;

//  
// GIE PEIE TMR0IE INTE IOCIE TMR0IF INTF IOCIF
		INTCON	=	0b11100000;
//					  |||||||+- IOCIF       
//					  ||||||+-- INTF    INTE
//					  |||||+--- TMR0IF    TMR0IF
//					  ||||+---- IOCIE      
//					  |||+----- INTE    INTE
//					  ||+------ TMR0IE    TMR0IE
//					  |+------- PEIE    
//					  +-------- GIE   

//		TMR1IE	= 1; //    TMR1
}//================================================================================



void sleep(void)//  
{
	TMR1IE	= 1; //    TMR1
	LATA=0;		//  
	LATB=0;
	LATC=0;
spim:			//      
	#asm
		SLEEP
		NOP
	#endasm
	CLRWDT(); 	//    +++++++++++++++++++++- 
	if(!POWER) goto spim;	// 	      
	TMR1IE	= 0; //    TMR1 (   "")
}//

void time(char hour, char minutes)//       
{
		tysc=hour%100/10;
		sotn=hour%10;
		dest=minutes%100/10;
		edin=minutes%10;
		
		edin=decod[edin];
		dest=decod[dest];
		sotn=decod[sotn];
		sotn |= 0b10000000;
		tysc=decod[tysc];
		
}//

void budilnik (void)// 
{
	if(rerareg01==1 && hour==hour1 && minutes==minutes1 && !budON1)
	{
		budON1=1;
		BEEPALARM=1;
	}	
	else if(minutes!=minutes1)budON1=0;
	
	if(rerareg02==1 && hour==hour2 && minutes==minutes2 && !budON2)
	{
		budON2=1;
		BEEPALARM=1;
	}	
	else if(minutes!=minutes2)budON2=0;	
	
	if(rerareg03==1 && hour==hour3 && minutes==minutes3 && !budON3)
	{
		budON3=1;
		BEEPALARM=1;
	}	
	else if(minutes!=minutes3)budON3=0;	

	if(rerareg04==1 && hour==hour4 && minutes==minutes4 && !budON4)
	{
		budON4=1;
		BEEPALARM=1;
	}	
	else if(minutes!=minutes4)budON4=0;		
}//